#include "df.h"
#include "textedit.h"

#include <QMessageBox>
#include <QtGui>

df::df(QWidget *parent, Qt::WFlags flags)
    : QWidget(parent, flags)
	,path("")
        ,ID_WARE(0)
        ,current_column(0)
{
  save_path = "";
	find_codec();
	ui.setupUi(this);

	QStringList labels;
    labels << tr("ID") << tr("Group") << tr("Manufakturer(Subgroup)") << tr("Modele") << tr("Picture")<< tr("Price") << tr("Description") << tr("State"); 
	ui.list_pho->setHeaderLabels(labels);
        QHeaderView *h = ui.list_pho->header();
        //h->setResizeMode(QHeaderView::ResizeToContents);
        h->setMovable(FALSE);
        
        h->setResizeMode(0, QHeaderView::Fixed);
        h->setResizeMode(6, QHeaderView::Stretch);
        h->setResizeMode(7, QHeaderView::Fixed);
        
        ui.list_pho->setDragEnabled(FALSE);
        ui.list_pho->setSelectionMode(QAbstractItemView::ExtendedSelection);
        
        QFont f(QApplication::font().family(), (int)(QApplication::font().pointSizeF()+2), QFont::Normal);
        ui.list_pho->setFont(f);
        
        ui.list_pho->resizeColumnToContents(0); 
        

	list_wares << "Motorola" << "Samsung"<< "LG" << "Siemens" << "Sofi" << "Fly" << "Sony Ericsson" << "Philips" << "Sony";

	connect(ui.remBtn,SIGNAL(clicked()),this,SLOT(slot_click_rem()));
	connect(ui.list_pho, SIGNAL(itemDoubleClicked(QTreeWidgetItem * , int )),
                this, SLOT(slot_edit_item( QTreeWidgetItem * , int )));
        //connect(ui.list_pho, SIGNAL(itemEntered(QTreeWidgetItem * , int )),
         //       this, SLOT(on_click_base( QTreeWidgetItem * , int )));
        connect(ui.list_pho, SIGNAL(currentItemChanged ( QTreeWidgetItem * , QTreeWidgetItem * ))
            , this, SLOT(slot_currentItemChanged(QTreeWidgetItem * , QTreeWidgetItem * )));
	//connect(this,SIGNAL(hide_toolbar(bool )),this,SLOT(slot_click_rem()));
	connect(ui.findBtn, SIGNAL(clicked()),this,SLOT(slot_find()));

	
	setCodecList();

        QTreeWidgetItem *item = new QTreeWidgetItem(ui.list_pho);
        generateId();
        item->setText(0,current);
        item->setText(1,"<NEW>");
        //item->setText(2,"<NEW>");
        
        ui.list_pho->setItemWidget(item, 7, new QCheckBox(tr("Exist"))); 
        
       ui.list_pho->setCurrentItem(item);
       
       int icount = ui.list_pho->columnCount();
  
       for(int i = 1; i<icount-1; i++)
       {
         ui.list_pho->setColumnWidth(i,185);
       }
}

df::~df()
{

}

void df::select_picture()
{
  QTreeWidgetItem *item = ui.list_pho->currentItem();
  
  QString s_old = item->text(4);
  
  QString s = QFileDialog::getOpenFileName(
                    this,
                    tr("Choose a file to select"),
                    path,
                    "Images (*.png *.gif *.jpg)");

  int i = s.lastIndexOf("/");
  
  path = s.mid(0,i+1);

  if(i!=-1)
  {
	  s = s.mid(i+1,s.length());
  }
  
  if(s.isEmpty())
    item->setText(4,s_old);
  else
    item->setText(4,s);
}

void df::slot_click_rem(void)
{
	/*QTreeWidgetItem *item = ui.list_pho->currentItem();

	if(item == NULL)
		return;
        
        if(ui.list_pho->topLevelItemCount ()<2)
          return;

	int n = QMessageBox::question(this,tr("Confirm delete"),
		tr("You really delete model: <b>%1</b>").arg(item->text(3)),
		tr("&Yes"), tr("&No"), QString(), 0, 1);

	if(n)
		return;

	delete item;*/
  
  QList<QTreeWidgetItem *>list_items = ui.list_pho->selectedItems();
  
  if(list_items.empty())
    return;
  
  if(ui.list_pho->topLevelItemCount ()<2)
    return;
  
  int n = QMessageBox::question(this,tr("Confirm delete"),
                                tr("You really delete selected items ?"),
                                tr("&Yes"), tr("&No"), QString(), 0, 1);

  if(n)
    return;
  
  while (!list_items.isEmpty())
    delete list_items.takeFirst();
}

void df::slot_generate(void)
{
	int n = ui.list_pho->topLevelItemCount();
	QTreeWidgetItem *item = NULL;
	int icount = ui.list_pho->columnCount();

	if(n == 0)
	{
        QMessageBox::information(this,tr("Info"),tr("No open datebase file"));
		return;
	}
        
        if(save_path.isEmpty())
          if(!get_directory())
            return;
            

        QString directory = save_path+"/bd_data.dat";
        
        QString line;
    
	for(int i=0; i<n; i++)
	{
		item = ui.list_pho->topLevelItem(i);
                if((item->text(1) == "<NEW>") || (item->text(2) == "<NEW>")
                    || (item->text(3) == "") || (item->text(5) == "")
                    || (item->text(1) == "") || (item->text(2) == ""))
			continue;
                
		line += item->text(0);
		
		for(int j=1; j<icount-1; j++)
			line += "|" + item->text(j);
                
                if(((QCheckBox*)(ui.list_pho->itemWidget(item,icount-1)))->isChecked())
                  line += "|X";
                else
                  line += "|-";
                
		line += "\n";
	}
               

        QFile file(directory);
        if (!file.open(QFile::WriteOnly | QFile::Text)) {
            QMessageBox::warning(this, tr("Save file"),
                                 tr("Cannot write file "));
           return;
        }

          int mib = ui.codec_s->itemData(ui.codec_s->currentIndex()).toInt();
	  QTextCodec *codec = QTextCodec::codecForMib(mib);

        QTextStream out(&file);
        out.setAutoDetectUnicode(false);
        out.setCodec(codec);
        out << line;

	file.close();
        
        //QMessageBox::about(this,tr("Information"),tr("File:")+" "+directory+" "+tr("is created"));
        emit emit_msg(tr("File:")+" "+directory+" "+tr("is saved."));
}


void df::on_OpenBtn_clicked()
{
	QString s = QFileDialog::getOpenFileName(
                    this,
                    tr("Choose a file to open"),
                    path,
                    "data files (*.dat)");
	if(s.isEmpty())
		return;

	
	QFile file(s);
        if (!file.open(QFile::ReadOnly | QFile::Text))
            return;

		if(ui.repCheck->isChecked())
		{
			ui.list_pho->clear();
			ID_WARE = 0;
		}
        
		QByteArray data = file.readAll();

		QStringList ls;

		int mib = ui.codec_s->itemData(
                      ui.codec_s->currentIndex()).toInt();
	
		QTextCodec *codec = QTextCodec::codecForMib(mib);
        
		QTextStream in(&data);
		in.setAutoDetectUnicode(false);
		in.setCodec(codec);
        while (!in.atEnd()) {
            QString line = in.readLine();
			ls << line;
        }

		QTreeWidgetItem *item = find_item(tr("<NEW>"));
		if(item != NULL)
		  delete item;

		for (int i = 0; i < ls.size(); ++i)
		{
			QString s = ls.at(i);
			QStringList list = s.split("|");
			add_group(list[1], list[2]);
			item = find_item(list[3]);
			if(item == NULL)
			{
				generateId();
				list[0]=current;
                                item = new QTreeWidgetItem();
                                ui.list_pho->addTopLevelItem(item);
                                
                                item->setText(0,list[0]);
                                item->setText(1,list[1]);
                                item->setText(2,list[2]);
                                item->setText(3,list[3]);
                                item->setText(4,list[4]);
                                item->setText(5,list[5]);
                                item->setText(6,list[6]);
                                QCheckBox *box = new QCheckBox(tr("Exist"));
                                if(list[7] == "X")
                                  box->setChecked(true);
                                else
                                  box->setChecked(false);
                                
                                ui.list_pho->setItemWidget(item,7, box);
                        }
		}
		file.close();

	item = new QTreeWidgetItem();
        generateId();
        item->setText(0,current);
	item->setText(1,tr("<NEW>"));
        ui.list_pho->addTopLevelItem(item);
        ui.list_pho->setItemWidget(item, 7, new QCheckBox(tr("Exist"))); 
}

void df::find_codec(void)
{
	QMap<QString, QTextCodec *> codecMap;
    QRegExp iso8859RegExp("ISO[- ]8859-([0-9]+).*");

    foreach (int mib, QTextCodec::availableMibs()) {
        QTextCodec *codec = QTextCodec::codecForMib(mib);

        QString sortKey = codec->name().toUpper();
        int rank;

        if (sortKey.startsWith("UTF-8")) {
            rank = 1;
        } else if (sortKey.startsWith("UTF-16")) {
            rank = 2;
        } else if (iso8859RegExp.exactMatch(sortKey)) {
            if (iso8859RegExp.cap(1).size() == 1)
                rank = 3;
            else
                rank = 4;
        } else {
            rank = 5;
        }
        sortKey.prepend(QChar('0' + rank));

        codecMap.insert(sortKey, codec);
    }
    codecs = codecMap.values();
}

void df::setCodecList()
{
	ui.codec_s->clear();
    foreach (QTextCodec *codec, codecs)
        ui.codec_s->addItem(codec->name(), codec->mibEnum());
}

// find item and remove him
QTreeWidgetItem* df::find_item(const QString& name, bool b_absolutly)
{
	int n = ui.list_pho->topLevelItemCount();
	QTreeWidgetItem *item = NULL;

	QString line;

	for(int i=0; i<n; i++)
	{
		item = ui.list_pho->topLevelItem(i);
		line = item->text(3/*2*/);

        if(b_absolutly)
		{
			if(!line.localeAwareCompare(name))
			    return item;
		}
		else
		{
			if(line.indexOf(name,0,Qt::CaseInsensitive)!=-1)
			    return item;
		}

    }
	return NULL;
}

void df::generateId()
{
	prev = current;
	++ID_WARE;
	QString s; // = QString::number(ID_WARE);
	s = QString("%1_%2").arg(ID_WARE).arg("id");
	
	current = s;
	//ui.id_ware->setText(s);
}    

void df::slot_find(void)
{
	QString s = ui.find_line->text();
	s = s.simplified();
		if(s.isEmpty())
			return;
	QTreeWidgetItem* item = find_item(s,false);

	ui.list_pho->setCurrentItem(item);
}


void df::add_group(const QString& str, const QString& ware)
{
	bool b = false;
        
	if((str != "") && (str != tr("<NEW>")))
	{
	  for (int i = 0; i < list_groups.size(); ++i)
	  {
		 if(list_groups.at(i) == str)
		 {
			 b = true;
			 break;
		 }
	  }

	  if(!b)
          {
		 list_groups+=str;
          }

	}
        
        b = false;

        if((ware != "") && (ware != tr("<NEW>")))
	{
		for (int i = 0; i < list_wares.size(); ++i)
	        {
		 if(list_wares.at(i) == ware)
		 {
		     b = true;
		     break;
		 }
	        }

	  if(!b)
          {
		 list_wares+=ware;
          }
	}
}


/*!
    \fn df::slot_edit_item( QTreeWidgetItem * item, int column )
 */
void df::slot_edit_item( QTreeWidgetItem * item, int column )
{
  switch(column)
  {
    case 4 : select_picture(); break;
    case 6 : load_deskr_editor(item); break;
  }
}

/*!
    \fn df::addItem(QTreeWidgetItem* item, QString name)
 */
QTreeWidgetItem* df::addItem()
{
  QTreeWidgetItem *item = new QTreeWidgetItem(ui.list_pho);
  generateId();
  item->setText(0,current);
  item->setText(1, "<NEW>"); 
 // item->setText(2, "<NEW>"); 
  ui.list_pho->setItemWidget(item, 7, new QCheckBox(tr("Exist"))); 
  
  return item;
}


/*!
    \fn df::edit_item(QTreeWidgetItem* , int )
 */
void df::edit_item(QTreeWidgetItem* item, int column )
{
  if(column != current_column)
    ui.list_pho->closePersistentEditor(item, current_column);
  ui.list_pho->openPersistentEditor(item, column);
  current_column = column;
  
  int i = ui.list_pho->indexOfTopLevelItem(item);
  if(i == ui.list_pho->topLevelItemCount()-1)
    addItem();
}

/*!
    \fn df::slot_currentItemChanged ( QTreeWidgetItem * current, QTreeWidgetItem * previous )
 */
void df::slot_currentItemChanged ( QTreeWidgetItem * current, QTreeWidgetItem * previous )
{
  if(!current || !previous )
    return;
  
  QComboBox* box_gr = (QComboBox*)(ui.list_pho->itemWidget(previous,1));
  QComboBox* box_gr2 = (QComboBox*)(ui.list_pho->itemWidget(previous,2));
  
  int col = ui.list_pho->currentColumn();
  
  QString s_group, s_manufakt;
  
  if((col != current_column) || ( current != previous ))
  {
    ui.list_pho->closePersistentEditor(previous, current_column);
    
    if(box_gr)
    {
      s_group = box_gr->currentText();
      delete box_gr;
    }
    
    if(box_gr2)
    {
      s_manufakt = box_gr2->currentText();
      delete box_gr2;
    }
   if(!s_group.isEmpty() )
     previous->setText(1,s_group);
   
   if(!s_manufakt.isEmpty() )
     previous->setText(2,s_manufakt);
   add_group(s_group,s_manufakt); 
  }
  
  switch(col)
  {
    case 2 : edit_manufakturer(current,current->text(2),col); break;
    case 1 : edit_group(current,current->text(1),col); break;
    case 3 :
    case 5 : edit_item(current, col); break;
  }
  
  preview_item(current->text(1),current->text(2),current->text(3),current->text(4),current->text(5),current->text(6),((QCheckBox*)(ui.list_pho->itemWidget(current,7)))->isChecked());  
}


/*!
    \fn df::load_deskr_editor()
 */
void df::load_deskr_editor(QTreeWidgetItem* item)
{
  //hide();
  setDisabled(TRUE);
  TextEdit* editor = new TextEdit(item->text(1),item->text(2),item->text(3),item->text(6),this);
  
  editor->showMaximized();
  
  QEventLoop *eventLoop = new QEventLoop(editor);
  
  connect(editor, SIGNAL(emit_exit()),eventLoop, SLOT(quit()));
  
  (void) eventLoop->exec();
  
  item->setText(6,editor->get_description_text());
  
  delete editor;
  //show();
  setDisabled(FALSE);
}


/*!
    \fn df::edit_group(QTreeWidgetItem* item, int column)
 */
void df::edit_group(QTreeWidgetItem* item, const QString& prev, int column)
{
  current_column = column;
  
  QComboBox *c_box_gr = new QComboBox();
  c_box_gr->setEditable(TRUE);
  //c_box_gr->addItem("<NEW>");
  c_box_gr->addItems(list_groups);
  c_box_gr->setEditText(prev);
  
  ui.list_pho->setItemWidget(item,1,c_box_gr);
}


/*!
    \fn df::edit_manufakturer(QTreeWidgetItem* item, int column)
 */
void df::edit_manufakturer(QTreeWidgetItem* item, const QString& prev, int column)
{
  current_column = column;
  
  QComboBox *c_box_manuf = new QComboBox();
  c_box_manuf->setEditable(TRUE);
  c_box_manuf->addItems(list_wares);
  
  c_box_manuf->setEditText(prev);
  
  ui.list_pho->setItemWidget(item,2,c_box_manuf);
}


/*!
    \fn df::preview_item(const QString& group, const QString& subgroup, const QString& item, const QString& picture, const QString& description, bool b=true )
 */
void df::preview_item(const QString& group, const QString& subgroup, const QString& item, const QString& picture, const QString& price, const QString& description, bool b )
{
  QString str_descrip;
  QString font = "<font color=\"#55aa00\"><b>%1</b> : </font>";
  QString font2 = "<font color=\"blue\"><b>%1</b> : </font>";
            
  str_descrip = "<html><head></head><body>";
  	
  str_descrip += font2.arg(tr("Info item"));
  	
  str_descrip += "<table border=0 width=100%>";
	      
  str_descrip += "<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Group"))+"</td>";
  str_descrip += "<td bgcolor=\"#EEF6FF\" width=95%>"+group+"</td></tr>";
	
  str_descrip+="<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Subgroup(manufacturer)"))+"</td>";
  str_descrip+="<td bgcolor=\"#FFFFFF\" width=95%>"+subgroup+"</td></tr>";
	
  str_descrip+="<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Model(item)"))+"</td>";
  str_descrip+="<td bgcolor=\"#EEF6FF\" width=95%>"+item+"</td></tr>";
	
  str_descrip+="<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Picture"))+"</td>";
  str_descrip+="<td bgcolor=\"#FFFFFF\" width=95%>"+picture+"</td></tr>";
  
  str_descrip+="<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Price"))+"</td>";
  str_descrip+="<td bgcolor=\"#EEF6FF\" width=95%>"+price+"</td></tr>";
  
  str_descrip+="<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Exist"))+"</td>";
  if( b )
    str_descrip+="<td bgcolor=\"#FFFFFF\" width=95%>"+tr("Yes")+"</td></tr>";
  else
    str_descrip+="<td bgcolor=\"#FFFFFF\" width=95%>"+tr("No")+"</td></tr>";
  
  str_descrip+="<tr><td bgcolor=\"#EEF6FF\" width=5%>"+font.arg(tr("Description"))+"</td>";
  QString s = description;
  
  //if(b)
  //  str_descrip+="<td bgcolor=\"#FFFFFF\" width=95%>"+s+"</td></tr>";
  //else
    str_descrip+="<td bgcolor=\"#EEF6FF\" width=95%>"+s+"</td></tr>";
  str_descrip +="</table>";
  str_descrip += "</body></html>";
  
  ui.textEdit->setHtml(str_descrip);
}


/*!
    \fn df::resizeEvent ( QResizeEvent * event )
 */
void df::keyReleaseEvent( QKeyEvent * e )
{   
  QTreeWidgetItem* previous = ui.list_pho->currentItem();
  if((e->key() == Qt::Key_Enter) || (e->key() == Qt::Key_Return))
  {
    ui.list_pho->closePersistentEditor(previous, current_column);
  }
  e->accept();
}


/*!
    \fn df::slot_save_as()
 */
void df::slot_save_as()
{
    save_path = "";
    
    slot_generate();
}


/*!
    \fn df::get_directory()
 */
bool df::get_directory()
{
  save_path = QFileDialog::getExistingDirectory(this,
      tr("Select directory to generate data base file"),
      "",
      QFileDialog::DontResolveSymlinks
          | QFileDialog::ShowDirsOnly);
  if (save_path.isEmpty())
        return false;
  
  return true;
}
