/********************************************************************************************************
 * PROGRAM      : web_bd
 * DATE - TIME  : jeudi 05 janvier 2006 - 19h19
 * AUTHOR       : Peter Komar ( peter_komar@mail.ru )
 * FILENAME     : main_w.cpp
 * LICENSE      : GPL
 * COMMENTARY   : 
 ********************************************************************************************************/ 

#include "main_w.h"

#include <QMessageBox>

const QString rsrcPath = ":/ico";

main_w::main_w(QWidget *parent)
    : QMainWindow(parent)
{
	ui.setupUi(this);

	df *main = new df(this);

	setCentralWidget(main);

	connect(ui.actionAbout, SIGNAL(triggered()), this, SLOT(slot_about()));
	connect(ui.actionExit,SIGNAL(triggered()), this, SLOT(slot_exit()));
	connect(ui.actionOpen,SIGNAL(triggered()), main, SLOT(on_OpenBtn_clicked()));
	connect(ui.actionGenerate_data,SIGNAL(triggered()), main, SLOT(slot_generate()));
        connect(ui.actionSave_as,SIGNAL(triggered()), main, SLOT(slot_save_as()));
        connect(main, SIGNAL(emit_msg(const QString&)),this, SLOT(show_status_msg(const QString&)));
               

	ui.toolBar->addAction(ui.actionOpen);
    ui.toolBar->addSeparator();
	ui.toolBar->addAction(ui.actionGenerate_data);
	ui.toolBar->addSeparator();
	ui.toolBar->addAction(ui.actionAbout);
        
        showMaximized();
}

main_w::~main_w()
{

}

void main_w::slot_about(void)
{
	QString s;
	s = QString("<b>%1</b>").arg("Web shop DB");
	s += tr(" - editor data base for web shop. Development by Peter Komar. 2006-2007. ");
	s += tr("For free used.");
	QMessageBox::about(this,tr("About"),s);
}

void main_w::slot_exit(void)
{
	close();
}



/*!
    \fn main_w::show_status_msg(const QString& )
 */
void main_w::show_status_msg(const QString& s)
{
  statusBar()-> showMessage(s,2000);
}
